--Requires Adventureworks database, free to download from Microsoft

--Cleanup Index if exists
DROP INDEX [IX_SalesOrderDetail_SaleOrderDetailID] ON [Sales].[SalesOrderDetail] WITH ( ONLINE = OFF )

--FREE Procedure Cache
DBCC FREEPROCCACHE
GO

--RUN Workload Simulators
--QueryStats PoSH 

SELECT text, cp.objtype, cp.size_in_bytes, cp.usecounts
FROM sys.dm_exec_cached_plans AS cp
CROSS APPLY sys.dm_exec_sql_text(cp.plan_handle) st
WHERE cp.cacheobjtype = N'Compiled Plan'
AND cp.objtype IN(N'Adhoc', N'Prepared') and dbid = '7'
AND cp.usecounts > 1
ORDER BY usecounts DESC
OPTION (RECOMPILE);

--Make sure to show subtree cost in execution plan
SET STATISTICS IO ON

SELECT SalesOrderID, SalesOrderDetailID 
FROM AdventureWorks2014.Sales.SalesOrderDetail 
WHERE SalesOrderDetailID = 68531 
GO

select count (*) from Sales.SalesOrderDetail 

--Create missing index

CREATE NONCLUSTERED INDEX [IX_SalesOrderDetail_SaleOrderDetailID] ON [Sales].[SalesOrderDetail] ( SalesOrderDetailID ASC) INCLUDE ( SalesOrderID) 

DROP INDEX [IX_SalesOrderDetail_SaleOrderDetailID] ON [Sales].[SalesOrderDetail] WITH ( ONLINE = OFF )
